SystemOrganization addCategory: #'GT-SpotterExtensions-CoreRoassal'!

!RTElement methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'AlexandreBergel 1/9/2015 18:08'!
spotterActDefault
	self view canvas camera translateTo: self position.
	RTBlink on: self.! !

RTInteraction subclass: #RTFindInAView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-CoreRoassal'!

!RTFindInAView methodsFor: 'hooks' stamp: 'AliakseiSyrel 1/19/2015 21:36'!
initializeElement: aView

	| mb |
	mb := RTMenuBuilder new.
	mb view: aView.
	mb menu: 'Find' callback: [ 
        GTSpotterMorph new
                        extent: 400@500;
                        spotterModel: (GTSpotter on: aView);
                        openCenteredInWorld ].
	mb build! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'StefanReichhart 2/24/2015 16:51'!
spotterRoassalExamplesFor: aStep
	<spotterOrder: 500>
	aStep listProcessor 
			allCandidates: [ (RTAbstractExample allSubclasses collect: #new) 
				flatCollect: [ :each | each gtExamples ] ];
			title: 'Roassal Examples';
			itemName: [ :example | example selector ];
			itemIcon: [ :example | [example iconForm] on: Error do: [ Form extent: 16@16  ] ];
			filter: (GTFilterBlock new 
				matcher: [ :item :context |
					item matchesQuery: (context cacheAt: #queryForRoassalExamples ifAbsentPut: [ context textLowercase splitOn: ' ' ]) ];
				yourself);
			wantsToDisplayOnEmptyQuery: false! !

!RTExampleSelection methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'AndreiChis 4/23/2015 11:31'!
matchesQuery: aSetOfNames
	| sourceCode |
	
	sourceCode := (self provider class >> self selector) sourceCode asLowercase.
	^ aSetOfNames allSatisfy: [ :each | sourceCode includesSubstring: each ]
! !

!RTExampleSelection methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'AndreiChis 4/23/2015 11:31'!
spotterPreviewExampleIn: aComposite
	<spotterPreview: 10>
	(self provider class canPerform: (self selector, 'Icon') asSymbol)
		ifTrue: [ 
			aComposite addBrickBack: (self iconForm asAlphaImageMorph
				layout: #center;
				scale: 2.0) asBrick ]

	! !

!RTView methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterElementsFor: aStep
	<spotterOrder: 10>
	^ aStep listProcessor
		title: 'Elements';
		candidatesLimit: 100;
		allCandidates: [ self elements ];
		itemName: [ :each | each model gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !
